from openerp.osv import osv
from openerp.osv import fields

class mi_modelo(osv.osv):
    _name = 'mi.modelo'
    _columns = {
        'name':fields.char('Name', size=16),
        'age':fields.integer('Age'),
    
    }

    def _capitalize_name(self, cr, uid, ids, values, context=None):
        if context is None: 
            context = {}
        ids = isinstance(ids, (int, long)) and [ids] or ids 
        #~ SELECT * FROM mi_modelo where id in (ids)
        modelo_brw = self.browse(cr, uid, ids, context=context)
        for each_brw in modelo_brw:
            if values.get('name'):
                values.update({'name':values['name'].upper()})
            else:
                name = each_brw.name.upper()
                values.update({'name':name})
        return values


    def write(self,cr, uid, ids, values, context=None):
        context = context or {}
        values = self._capitalize_name(cr, uid, ids, values, context)
        return super(mi_modelo,self).write(cr, uid, ids, values, context)


class mi_modelo2(osv.osv):
    _name = 'mi.modelo'
    _inherit = 'mi.modelo'
    _columns = {
        'surname':fields.char('Surname', size=16),
    
    }


    def _capitalize_name(self, cr, uid, ids, values, context=None):
        return super(mi_modelo2,self)._capitalize_name(cr, uid, ids, values, context=None)

class mi_modelo3(osv.osv):
    _inherit = 'mi.modelo'
    _columns = {
        'name':fields.char('Name', size=256),
    } 

class otro_modelo(osv.osv):
    _name = 'otro.modelo'
    _inherit = 'mi.modelo'

    _columns ={
        'rif':fields.char('Registro de Identidad Fiscal', size=10, required=True)
    }

    def _capitalize_name(self, cr, uid, ids, values, context=None):
        context = context or {}
        
        ids = isinstance(ids, (int, long)) and [ids] or ids 
        #~ SELECT * FROM mi_modelo where id in (ids)
        modelo_brw = self.browse(cr, uid, ids, context=context)
        for each_brw in modelo_brw:
            if values.get('surname', False):
                values.update({'surname':values['surname'].upper()})
            else:
                surname = each_brw.surname.upper()
                values.update({'surname':surname})
        return super(otro_modelo,self)._capitalize_name(cr, uid, ids, values, context=None)


class mi_marca(osv.Model):
    _name = 'mi.marca'
    _columns = {
        'brand':fields.selection([  ('toyota','Toyota'),
                                    ('nissan','Nissan'),   
                                    ('ford','Ford'),
                                    ('gm','GM')], 'Brand', required=True),
        'hybrid':fields.boolean('Is it hybrid?')
    }
    _rec_name = 'brand'


class mi_carro(osv.Model):
    _name = 'mi.carro'    
    _inherits = {
                    'mi.modelo': 'modelo_id',
                    'mi.marca' : 'marca_id',
                    }
    _columns = {
        'modelo_id':fields.many2one('mi.modelo', 'Modelo',required=True, ondelete="cascade"),
        'marca_id':fields.many2one('mi.marca','Marca',required=True, ondelete="cascade"),
        'car_name':fields.char('Car Name', size=256, required=True),
        }
