from openerp.osv import osv,fields

class CreateAttendeeWizard(osv.TransientModel):
    _name = 'openacademy.create.attendee.wizard'

    def _get_active_sessions(self, cr, uid, context):
        context = context or {}
        if context.get('active_model') == 'openacademy.session':
            return context.get('active_ids', False)
        return False

    _columns = {

        'session_ids': fields.many2many('openacademy.session', 'sess_att_rel',
            string='Session', required=True),
        'attendee_ids': fields.one2many('openacademy.attendee.wizard',
            'wizard_id', 'Attendees'),
    } 

    _defaults = {
            'session_ids': _get_active_sessions,
            }





    def action_add_attendee(self, cr, uid, ids, context=None):
        context = context or {}
        session_model = self.pool.get('openacademy.session')
        wizard = self.browse(cr, uid, ids[0], context=context)
        session_ids = [sess.id for sess in wizard.session_ids]
        att_data = [{'partner_id': att.partner_id.id} for att in wizard.attendee_ids]
        values = {'attendee_ids': [(0, 0, data) for data in att_data]}
        session_model.write(cr, uid, session_ids,values, context)
        return {}
 


class AttendeeWizard(osv.TransientModel):
    _name = 'openacademy.attendee.wizard'
    _columns = {
        'partner_id': fields.many2one('res.partner', 'Partner', required=True),
        'wizard_id':fields.many2one('openacademy.create.attendee.wizard'),
    }


